#include <iostream>
#include <iomanip>
#include <cstring>
#include <bitset>
#include <climits>

int main(){
    const char* array_string_00 {"Hello"}; // questo funziona ma genera un warning
    char array_string_01[10] {"World"};
    char array_string_02[10];
    std::size_t mem_size {2};


    std::cout << "testing strcpy:" << std::endl;
    std::cout << "\tarray_string_00 bfeore: " << array_string_00 << std::endl;
    std::cout << "\tarray_string_02 bfeore: " << array_string_02 << std::endl;
    // char* strcpy( char* dest, const char* src );
    strcpy(array_string_02, array_string_00);                
    std::cout << "\tarray_string_00 after: " << array_string_00 << std::endl;
    std::cout << "\tarray_string_02 after: " << array_string_02 << std::endl;

    
    std::cout << "testing strncpy:" << std::endl;
    std::cout << "\tarray_string_01 bfeore: " << array_string_01 << std::endl;
    std::cout << "\tarray_string_02 bfeore: " << array_string_02 << std::endl;
    // char* strncpy( char* dest, const char* src, std::size_t count );
    strncpy(array_string_02, array_string_01, mem_size);     
    std::cout << "\tarray_string_01 after: " << array_string_01 << std::endl;
    std::cout << "\tarray_string_02 after: " << array_string_02 << std::endl;


    std::cout << "testing strcat:" << std::endl;
    std::cout << "\tarray_string_00 bfeore: " << array_string_00 << std::endl;
    std::cout << "\tarray_string_02 bfeore: " << array_string_02 << std::endl;
    // char* strcat( char* dest, const char* src );
    strcat(array_string_02, array_string_00);                
    std::cout << "\tarray_string_00 after: " << array_string_00 << std::endl;
    std::cout << "\tarray_string_02 after: " << array_string_02 << std::endl;

    
    std::cout << "testing strncat:" << std::endl;
    std::cout << "\tarray_string_00 bfeore: " << array_string_00 << std::endl;
    std::cout << "\tarray_string_01 bfeore: " << array_string_01 << std::endl;
    // char* strncat( char* dest, const char* src, std::size_t count );
    strncat(array_string_01, array_string_00, mem_size);
    std::cout << "\tarray_string_00 after: " << array_string_00 << std::endl;
    std::cout << "\tarray_string_01 after: " << array_string_01 << std::endl;


    std::cout << "testing strxfrm:" << std::endl;
    std::cout << "\tarray_string_00 bfeore: " << array_string_00 << std::endl;
    std::cout << "\tarray_string_02 bfeore: " << array_string_02 << std::endl;
    // std::size_t strxfrm( char* dest, const char* src, std::size_t count );
    strxfrm(array_string_01, array_string_00, mem_size);
    std::cout << "\tarray_string_00 after: " << array_string_00 << std::endl;
    std::cout << "\tarray_string_02 after: " << array_string_02 << std::endl;


    std::cout << "testing strlen:" << std::endl;
    // std::size_t strlen( const char* str );
    std::cout << "\tarray_string_00 len: " << strlen(array_string_00) << std::endl;
    std::cout << "\tarray_string_01 len: " << strlen(array_string_01) << std::endl;
    std::cout << "\tarray_string_02 len: " << strlen(array_string_02) << std::endl;
 

    std::cout << "testing strcmp:" << std::endl;
    // int strcmp( const char* lhs, const char* rhs );
    std::cout << "\tcompare array_string_00 whit array_string_00: " << strcmp(array_string_00, array_string_00) << std::endl;
    std::cout << "\tcompare array_string_00 whit array_string_01: " << strcmp(array_string_00, array_string_01) << std::endl;
    std::cout << "\tcompare array_string_00 whit array_string_02: " << strcmp(array_string_00, array_string_02) << std::endl;

 
    std::cout << "testing strncmp:" << std::endl;
    // int strncmp( const char* lhs, const char* rhs, std::size_t count );
    std::cout << "\tcompare mem_size most array_string_00 whit array_string_00: " << strncmp(array_string_00, array_string_00, mem_size) << std::endl;
    std::cout << "\tcompare mem_size most array_string_00 whit array_string_01: " << strncmp(array_string_00, array_string_01, mem_size) << std::endl;
    std::cout << "\tcompare mem_size most array_string_00 whit array_string_02: " << strncmp(array_string_00, array_string_02, mem_size) << std::endl;
 

    std::cout << "testing strcoll:" << std::endl;
    // int strcoll( const char* lhs, const char* rhs );
    std::cout << "\tcompare mem_size most array_string_00 whit array_string_00: " << strcoll(array_string_00, array_string_00) << std::endl;
    std::cout << "\tcompare mem_size most array_string_00 whit array_string_01: " << strcoll(array_string_00, array_string_01) << std::endl;
    std::cout << "\tcompare mem_size most array_string_00 whit array_string_02: " << strcoll(array_string_00, array_string_02) << std::endl;


    strcpy(array_string_01, "testoc");
    std::cout << "testing strchr:" << std::endl;
    // char* strchr(       char* str, int ch );
    std::cout << "\tfind char c on array_string_00 at pos: " << strchr(array_string_01, 'c') << std::endl;


    std::cout << "testing strrchr:" << std::endl;
    // char* strrchr(       char* str, int ch );
    std::cout << "\tfind char c on array_string_00 at pos: " << strrchr(array_string_01, 'c') << std::endl;


    strcpy(array_string_01, "testoc");
    strcpy(array_string_02, "te");
    std::cout << "testing strspn:" << std::endl;
    // size_t strspn( const char* dest, const char* src );
    std::cout << "\t find array_string_02 in  array_string_01 lenght: " << strspn(array_string_01, array_string_02) << std::endl;


    std::cout << "testing strcspn:" << std::endl;
    // size_t strspn( const char* dest, const char* src );
    std::cout << "\t find array_string_02 in  array_string_01 lenght: " << strcspn(array_string_01, array_string_02) << std::endl;


    std::cout << "testing strpbrk:" << std::endl;
    const char* str = "hello world, friend of mine!";
    const char* sep = " ,!";
    unsigned int cnt = 0;
    do
    {
        str = std::strpbrk(str, sep); // find separator
        std::cout << std::quoted(str) << '\n';
        if (str)
            str += std::strspn(str, sep); // skip separator
        ++cnt; // increment word count
    } while (str && *str);
    std::cout << "There are " << cnt << " words\n";


    strcpy(array_string_01, "testoc");
    strcpy(array_string_02, "to");
    std::cout << "testing strstr:" << std::endl;
    // const char* strstr( const char* haystack, const char* needle );
    std::cout << "\t find array_string_02 in  array_string_01 lenght: " << strstr(array_string_01, array_string_02) << std::endl;


    std::cout << "testing strtok:" << std::endl;
    // char* strtok( char* str, const char* delim );
    char input[] = "one + two * (three - four)!";
    const char* delimiters = "! +- (*)";
    char* token = std::strtok(input, delimiters);
    while (token)
    {
        std::cout << std::quoted(token) << ' ';
        token = std::strtok(nullptr, delimiters);
    }


    std::cout << "\ntesting memchr:" << std::endl;
    // memchr(const void* s, int c, size_t n);    
    const char str_chr[] = "ABCDEFG";
    const int chars[] = {'D', 'd'};
    for (size_t i = 0; i < sizeof chars / (sizeof chars[0]); ++i)
    {
        const int c = chars[i];   
        const void* ps = memchr(str_chr, c, strlen(str_chr));
        ps ? printf ("character '%c'(%i) found: %s\n", c, c, ps)
           : printf ("character '%c'(%i) not found\n", c, c);
    }


    std::cout << "testing memcmp:" << std::endl;
    // void* memcpy( void* dest, const void* src, std::size_t count );
    char source_cmp[] = "once upon a daydream...", dest_cmp[4];
    std::cout << "\tsource before: " << source_cmp << std::endl;
    std::cout << "\tdest before: " << dest_cmp << std::endl;
    std::memcpy(dest_cmp, source_cmp, sizeof dest_cmp);
    std::cout << "\tsource after: " << source_cmp << std::endl;
    std::cout << "\tdest after: " << dest_cmp << std::endl;
 

    std::cout << "testing memset:" << std::endl;
    // void* memset( void* dest, int ch, std::size_t count );
    int a[4];
    using bits = std::bitset<sizeof(int) * CHAR_BIT>;
    std::memset(a, 0b1111'0000'0011, sizeof a);
    for (int ai : a)
        std::cout << bits(ai) << '\n';
 

    std::cout << "testing memcpy:" << std::endl;
    std::cout << "\tarray_string_00 bfeore: " << array_string_00 << std::endl;
    std::cout << "\tarray_string_01 bfeore: " << array_string_01 << std::endl;
    // void* memcpy( void* dest, const void* src, std::size_t count );
    std::memcpy(array_string_01, array_string_00, mem_size);      
    std::cout << "\tarray_string_00 after: " << array_string_00 << std::endl;
    std::cout << "\tarray_string_01 after: " << array_string_01 << std::endl;


    std::cout << "testing memmove:" << std::endl;
    // void* memmove( void* dest, const void* src, std::size_t count );
    char str_memmove[] = "1234567890";
    std::cout << "\tbefore: " << str_memmove << '\n';
    std::memmove(str_memmove + 4, str_memmove + 3, 3); // copies from [4, 5, 6] to [5, 6, 7]
    std::cout << "\tafter: " << str_memmove << '\n';
 
    std::cout << "testing strerror:" << std::endl;
    // strerror(int errnum);
 
}

